     #define TRUE .T.
     #define NUM_COLS 4
     #include 'inkey.ch'

     FUNCTION Main

     LOCAL oEmpBrowse, aColObjects[NUM_COLS]
     LOCAL nKey
     LOCAL cScrSave, nCnt

     USE employee NEW

     * Use constructor function to create 1 TBrowse object
     oEmpBrowse := TBrowseDB( 5, 10, 20, 70 )

     * Use constructor function to create 4 new TBColumn objects
     aColObjects[1] := TBColumnNew( "Last Name",  {|| employee->last} )
     aColObjects[2] := TBColumnNew( "First Name", {|| employee->first} )
     aColObjects[3] := TBColumnNew( "Hire Date",  {|| employee->hire_date} )
     aColObjects[4] := TBColumnNew( "Salary" ,    {|| employee->mo_sal} )

     * Tell TBrowse object about the TBColumn objects
     FOR nCnt := 1 TO LEN(aColObjects)
          oEmpBrowse:addColumn(aColObjects[nCnt])
     NEXT

     * Customize TBrowse object with separators
     oEmpBrowse:headSep := CHR(196)
     oEmpBrowse:colSep := CHR(179)

     * Save screen contents where browse will appear
     cScrSave := SAVESCREEN( 5, 10, 20, 70 )

     * Begin primary TBrowse loop
     WHILE TRUE
          GenStab( oEmpBrowse )   // Perform generic stabilization

          nKey := INKEY(0)        // Get a keystroke

          IF nKey == K_ESC        // ESC is a good exit key
               EXIT
          ELSE
               GenKey( oEmpBrowse, nKey )  // Perform generic key handling
          ENDIF
     END

     RESTSCREEN( 5, 10, 20, 70, cScrSave)

     RETURN NIL

     /***
     *
     * GenStab( oTBObject ) --> NIL
     *
     */

     FUNCTION GenStab( oTBObject )

     WHILE !oTBObject:stabilize()
     END

     RETURN NIL

     /***
     *
     * GenKey( oTBObject, nKey ) --> NIL
     *
     */

     FUNCTION GenKey( oTBObject, nKey )

          DO CASE
               CASE nKey == K_UP
                    oTBObject:up()

               CASE nKey == K_DOWN
                    oTBObject:down()

               CASE nKey == K_PGUP
                    oTBObject:pageUp()

               CASE nKey == K_PGDN
                    oTBObject:pageDown()

               CASE nKey == K_LEFT
                    oTBObject:left()

               CASE nKey == K_RIGHT
                    oTBObject:right()
          ENDCASE

     RETURN NIL


